package com.fp.persistence.parmas.inte;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TARMLECTURADETALLE*/
@Embeddable
public class TarmLecturaDetalleKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="CLECTURA", nullable=false,updatable=false)

/**
* null
*/
private Long clectura;

@Column(name="CODIGOTAG", nullable=false,updatable=false)

/**
* null
*/
private String codigotag;

/**Contructor por defecto*/
public TarmLecturaDetalleKey(){}
/**Contructor de TarmLecturaDetalleKey
@param pClectura null
@param pCodigotag null
*/
public TarmLecturaDetalleKey(Long pClectura,String pCodigotag){
 clectura=pClectura;
 codigotag=pCodigotag;
}
/**Obtiene el valor de clectura
@return valor de clectura*/
public Long getClectura(){
  return clectura;
}
/**Fija el valor de clectura
@param pClectura nuevo Valor de clectura*/
public void setClectura(Long pClectura){
  clectura=pClectura;
}

/**Obtiene el valor de codigotag
@return valor de codigotag*/
public String getCodigotag(){
  return codigotag;
}
/**Fija el valor de codigotag
@param pCodigotag nuevo Valor de codigotag*/
public void setCodigotag(String pCodigotag){
  codigotag=pCodigotag;
}

/**Implementacion de la comparacion de TarmLecturaDetalleKey
@param o Objeto de comparacion
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TarmLecturaDetalleKey))return false;
  TarmLecturaDetalleKey that = (TarmLecturaDetalleKey) o;
  if (this.getClectura() == null || that.getClectura() == null){
      return false;
  }
  if (! this.getClectura().equals(that.getClectura())){
    return false;
  }
  if (this.getCodigotag() == null || that.getCodigotag() == null){
      return false;
  }
  if (! this.getCodigotag().equals(that.getCodigotag())){
    return false;
  }
  return true;
}
/**Implementacion del metodo hashCode bajo el patron de Bloch
@return hashCode de la instancia TarmLecturaDetalleKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getClectura() == null ? 0 : this.getClectura().hashCode());
    result = result * 37 + (this.getCodigotag() == null ? 0 : this.getCodigotag().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
